#------------------------------------------------------------------------------
#    Copyright (C) 2009 Florian Schanda <florian@schanda.org.uk>
#
#    This file is part of the Warzone Map Tools.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program. If not, see <http://www.gnu.org/licenses/>.
#------------------------------------------------------------------------------

def showset(outline, highlight=set()):
    """ This function pretty print a set of int pairs. The optional
        highlight parameter will color a certain (sub)set of values.
    """
    tl = (min(p[0] for p in outline), min(p[1] for p in outline))
    br = (max(p[0] for p in outline), max(p[1] for p in outline))

    def is_inside(p):
        return (p[0] >= tl[0] and
                p[0] <= br[0] and
                p[1] >= tl[1] and
                p[1] <= br[1])

    print "Showing set of size %u (%s to %s), higligting %u tiles." % \
        (len(outline), repr(tl), repr(br), len(highlight))
    for y in xrange(tl[1]-1, br[1]+2):
        tmp = ""
        for x in xrange(tl[0]-1, br[0]+2):
            c = " "
            if (x, y) in outline:
                c = "#"
            elif not is_inside((x, y)):
                c = ":"
            if (x, y) in highlight:
                if (x, y) in outline:
                    c = "\033[33m#\033[0m"
                else:
                    c = "\033[43m \033[0m"
            tmp += c
        print tmp
