/*****************************************************************************
 *  Copyright (C) 2009 Florian Schanda <florian@schanda.org.uk>              *
 *                                                                           *
 *  This file is part of the Warzone Map Tools.                              *
 *                                                                           *
 *  This program is free software: you can redistribute it and/or modify     *
 *  it under the terms of the GNU General Public License as published by     *
 *  the Free Software Foundation, either version 3 of the License, or        *
 *  (at your option) any later version.                                      *
 *                                                                           *
 *  This program is distributed in the hope that it will be useful,          *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             *
 *  GNU General Public License for more details.                             *
 *                                                                           *
 *  You should have received a copy of the GNU General Public License        *
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.     *
 *****************************************************************************/

#ifndef _SORTED_LIST_H
#define _SORTED_LIST_H

typedef struct node {
  int coord; /* This must be unique */
  int cost;  /* This must be minimal */
  struct node * next;
} Node;

typedef struct {
  Node * head;
} SortedList;

extern SortedList * new_slist(void);
extern void delete_slist(SortedList *l);

extern void slist_add(SortedList *l, int coord, int cost);
extern void slist_pop(SortedList *l);
extern int slist_head_coord(SortedList *l);
extern int slist_head_cost(SortedList *l);
extern int slist_is_empty(SortedList *l);

#endif
